Subject: Re: [PATCH v2 4/4] Add explicit Cygwin check to guard WIN32 header inclusion

From: Johannes Sixt <[email-masked]>
Date: Mon, 09 Nov 2009 08:20:38 +0100

Ramsay Jones schrieb:
> Since commit 435bdf8c ("Make usage of windows.h lean and mean",
> 16-9-2009), the amount of code potentially including the WIN32
> API header files has greatly increased. In particular, the Cygwin
> build is at greater risk of inadvertently including WIN32 code
> within preprocessor sections protected by the WIN32 or _WIN32
> macros.

Thanks, this makes the problem pretty clear that you want to solve.

> The previous commit message, along with comments elsewhere, assert
> that the WIN32 macro is not defined on Cygwin. Currently, this is
> true for the cygwin build. However, the cygwin platform can be
> used to develop WIN32 GUI, WIN32 console, and POSIX applications.
> Indeed it is possible to create applications which use a mix of
> the WIN32 API and POSIX code (eg git!).

In this paragraph, you are only saying that cygwin comes with headers and
libraries that can be used to write code using the Windows API in addition
to the POSIX headers and libraries. (I'm just asking, not complaining;
perhaps this could be stated differently.)

> Unlike native WIN32 compilers, gcc on cygwin does not automatically
> define the _WIN32 macro. However, as soon as you include the
> <windows.h> header file, the _WIN32 and WIN32 macros are defined.
> 
> In order to reduce the risk of problems in the future, we protect
> the inclusion of the windows header with an explicit check for
> __CYGWIN__. Also, we move the other use of the <windows.h> header
> from compat/win32.h to compat/cygwin.c

But I sense a contradiction here. Above you are arguing that much more
WIN32 code is included, but here you are saying that the explicit check
for __CYGWIN__ is just a safety measure to protect us from failures in
future changes. Indeed, looking at the code it seems that this extra check
is *currently* not necessary:

- Cygwin does not define WIN32, hence, in the original code of this hunk,

> diff --git a/git-compat-util.h b/git-compat-util.h
> index ef60803..c4b9e5a 100644
> --- a/git-compat-util.h
> +++ b/git-compat-util.h
> @@ -65,10 +65,10 @@
>  #define _NETBSD_SOURCE 1
>  #define _SGI_SOURCE 1
>  
> -#ifdef WIN32 /* Both MinGW and MSVC */
> -#define WIN32_LEAN_AND_MEAN  /* stops windows.h including winsock.h */
> -#include <winsock2.h>
> -#include <windows.h>
> +#if defined(_WIN32) && !defined(__CYGWIN__) /* Both MinGW and MSVC */
> +# define WIN32_LEAN_AND_MEAN  /* stops windows.h including winsock.h */
> +# include <winsock2.h>
> +# include <windows.h>
>  #endif
>  
>  #include <unistd.h>

windows.h is not included in cygwin. (Nor is it in the changed version.)

- The other files that include windows.h are compat/win32.h and nedmalloc.
The latter isn't used on cygwin.

- win32.h is included only from cygwin.c, mingw.c, and msvc.c. Only the
first one is used by cygwin, and since it is a .c file, pulling in
windows.h can only concern code in cygwin.c, but not code.

IOW, I disagree with your analysis that a lot of code suffers from
windows.h pollution. What am I missing?

-- Hannes